/**
 * Responsive HTML Table
 * Made by  bogdi.ro, Bogdan Borca, Timisoara, RO, 2016
 * 
 * 
 */
	var newTableHead;
	var hiddenHeader = 0;
	var headerHeight = 0;
	var tableOffset = 9999;
	var tableRows;				// does not contains th
	var tableColumns;			// 
	var tableId = '#regular-table';
	var tableHeadId = "#regular-table-head";
	var tableAsObject = [];
	var tableTH = [];
	var cellMinWidth = 130;
	var lastLevel = 0;
	var oHeaders = [];
	var oHeadersClass = '.res-table-oheader';
	var maxHeaderHeight = 0;
	var rowBlocks = [];
	var scrollBlocks = [];
	var heightOfTheFixed = 0;
	var oldFixedBlock = 0;

	jQuery(document).ready(function() {
		getTableBody();
		jQuery(window).load(onLoad);
		jQuery(window).resize(onResize);
		jQuery(window).scroll(onScroll);
		jQuery(window).unload(onUnload);
		tableOffset = $(tableId).offset().top;
	});

	function onLoad() {
		jQuery('.responsive-table-th-link').each(function() {
			jQuery(this).click(function() {
  				window.open(jQuery(this).attr("href"));
			});
		});
		onResize();				
	}
	
	function getTableHeader() {
		var currentTHS = jQuery(".rht-head");
		
		newTableHead = $("<thead></thead>");
		newTableHead.css("position", "fixed").			
				css("top", headerHeight + "px").
				css("left", currentTHS[0].offsetLeft + "px");
		newTableHead.attr("id", "newTableHead");
			
		var newTableHeadRow = $("<tr></tr>");
		
		for(var ith = 0; ith < currentTHS.length; ith++) {
			var newHC = $(currentTHS[ith]).clone();
			newHC.css("left", currentTHS[ith].offsetLeft).
							css("width", currentTHS[ith].clientWidth);
			newHC.removeClass("rht-head");
			newTableHeadRow.append(newHC);
		};
		newTableHead.append(newTableHeadRow);
	}
	
	function onResize() {
		oHeaders = [];
		if ((tableColumns * cellMinWidth) < jQuery('body').width()) {
			changeTable(0);
			getTableHeader();
			return;
		} else {
			newTableHead = null;
		}
		var rows = tableRows;
		while (((rows + 1) * cellMinWidth > (jQuery('body').width())) && (rows > 0)) {
			rows--;
		}
		changeTable(tableRows - rows);
		getOHeaders();
		setTimeout(function(){ 
			if (oHeaders.length == 0) {
				return;
			}
			scrollBlocks = [];
			for(var i = 0; i < rowBlocks.length; i++) {
				var hPos = 0;
				for (var j = 0; j < i; j++)
					hPos += rowBlocks[j];
				scrollBlocks.push(jQuery(oHeaders[hPos]).offset().top);
			
			}				
		}, 500);
				
	}
	
	function freezeTableHeaderIf() {
		if (newTableHead == null) {
			return;
		}
		
		var offset = $(this).scrollTop();

		if ((offset >= (tableOffset - headerHeight)) && (hiddenHeader == 0)) {
			jQuery(tableHeadId).css("visibility", "hidden");
			$(tableId).prepend(newTableHead);
			hiddenHeader = 1;
		} else if ((offset < (tableOffset - headerHeight)) && (hiddenHeader == 1)) {
			jQuery(tableHeadId).css("visibility", "visible");
			jQuery("#newTableHead").remove();
			hiddenHeader = 0;
		}
	}
	
	function onScroll() {
		if (oHeaders.length == 0) {
			freezeTableHeaderIf();			
			return;
		}
		// -1 -> no change 
		// 0 -> no fixed block
		// 1 -> first block is fixed
		// 2 -> second block is fixed
		var fixedBlock = getFixedBlock();
		if (fixedBlock == -1)
			return;
		
		if ((fixedBlock == 0) || (fixedBlock != oldFixedBlock)) {
			oldFixedBlock = 0;
			jQuery('.fixed-header').remove();
			jQuery('.visibilityHC').removeClass('visibilityHC');
		}
		
		if (fixedBlock == oldFixedBlock)
			return;
		
		maxHeaderHeight = 0;
		oldFixedBlock = fixedBlock;

		// Get the end point for oHeaders[] to begin freezing headers
		h = rowBlocks[fixedBlock - 1];
		for(var i = 0; i < fixedBlock - 1; i++) {
			h += rowBlocks[i];
		}

		// Add new fixed header
		for(var i = h - 1; i >= h - rowBlocks[fixedBlock - 1]; i--) {
			var oHeaderParent = $(oHeaders[i]).parent();
			var fixedHC = $(oHeaders[i]).clone();
			fixedHC.css('left', jQuery(oHeaders[i]).offset().left + 'px').
					css('top', headerHeight + 'px').
					css('width', oHeaders[i].clientWidth + 'px');
			fixedHC.addClass('fixed-header');
			$(oHeaders[i]).addClass("visibilityHC");
			oHeaderParent.append(fixedHC);			
			if (maxHeaderHeight < oHeaders[i].clientHeight) {
				maxHeaderHeight = oHeaders[i].clientHeight;
			}		
		}
		// Modify all other fixed headers heigth to the max		
		jQuery(".fixed-header").css('height', maxHeaderHeight + 'px');
	}	

	function onUnload() {
		jQuery(window).off("resize");
	}
	
	/*
	* Get table cells
	* 
	*/
		
	function getTableBody() {
		tableRows = -1;
		jQuery(tableId + " tr").each(function () {
			tableColumns = 0;
			jQuery('td', this).each(function () {
				tableAsObject[tableRows + "-" + tableColumns] = this;
				tableColumns++;	
			})
			tableRows++;
		});
		var tableHeaders = 0;
		jQuery(tableId + " th").each(function () {
			tableTH[tableHeaders++] = this;
		});
	}

	/*
	* Calculate the number of rows/block of original table's 
	* column header. The result is an array which contains
	* how many block are and how many columns each block has. 
	*/

	function calculateNumberOfRowBlocks(level) {
		var tr = tableRows;
		var difColumns = (level * 2 > tr)?(tr - level):level;

		var rb = 1;
		var columns = tr - level;
		rowBlocks = [columns];
		while (columns + difColumns <= tr) {
			rowBlocks[rb++] = difColumns;
			columns = columns + difColumns;
		}
		if (columns < tr)
			rowBlocks[rb] = tr - columns;
	}

	/*
	* Build body based on rowBlocks.
	* For example rowBlocks can be like [3, 3, 2] wich means 3 columns/ 3 columns/ 2 columns
	* Each block of columns will be a matrix rowBlocks[i]/tableColumns
	*/

	function buildResTable() {
		var tableGroup = 0;
		var htmlRTBody = createResTable();
		for(var i = 0; i < rowBlocks.length; i++) {
			for(var j = 0; j < tableColumns; j++) {
				// tr class from original table will be lost
				var row = jQuery('<tr></tr>');
				jQuery(tableTH[j]).clone(true).appendTo(row);
				for(var group = 0; group < rowBlocks[i]; group++)  {
					jQuery(tableAsObject[(group + tableGroup) + "-" + j]).clone().appendTo(row);
				}
				htmlRTBody.append(row);				
			}
			tableGroup += rowBlocks[i];
		}
	}
		
	/*
	* Build the table based on resTable
	* Returns the body
	*/

	function createResTable() {
		var htmlRTable = jQuery('<table></table>');
		htmlRTable.attr('id', 'responsive-table');
		htmlRTable.addClass('responsive-table-class');
		jQuery('.entry-content').prepend(htmlRTable);
		htmlRTable.insertBefore(tableId);

		jQuery(tableId).children().each(function () {
			if (this.nodeName == 'CAPTION') {
				jQuery(this).clone().appendTo(htmlRTable);
			}
		});
		var htmlRTBody = jQuery('<tbody></tbody>');
		htmlRTable.append(htmlRTBody);

		return htmlRTBody;
	}


	/*
	* Change table based on level.
	* Level is calculated based on resolution.
	*/
	
	function changeTable(level) {
		if (level == 0) {
			lastLevel = 0;
			jQuery('#responsive-table').remove();
			jQuery(tableId).css('display','inline-table');
			return;
		}
		if (lastLevel == level)
			return;
		lastLevel = level;
		jQuery(tableId).css('display','none');
		var rt = jQuery('#responsive-table');
		if (rt.length > 0) 
			rt.remove();
		// Calculate rowBlocks
		// rowBlocks are rows grouped by original tables header columns
		// eg. rowBlocks = [2, 2, 2, 1] for 8 rows table, one row is saved for header
		calculateNumberOfRowBlocks(level);
		buildResTable();
	}

	
	function getOHeaders() {
		jQuery(oHeadersClass).each(function () {
			if (jQuery(this).is(":visible")) 
				oHeaders.push(this);
		});	

	}

	function getFixedBlock() {	
		var ws = (window.scrollY || window.pageYOffset) + headerHeight + heightOfTheFixed  ;
		for (var sc = 0; sc <= (scrollBlocks.length - 1); sc++) {
			if ((ws >= (scrollBlocks[sc])) && (ws <= (((sc + 1) == scrollBlocks.length)?(ws + 1):scrollBlocks[sc + 1]))) {
				heightOfTheFixed  = jQuery(oHeaders[sc]).height();
				return sc + 1;
			}
		}
		return 0;
	}

	